diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/reiserfs/inode.c linux-2.4.22-ashuariadevel/fs/reiserfs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/reiserfs/inode.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/reiserfs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 17,23 ****
  #define GET_BLOCK_READ_DIRECT 4  /* read the tail if indirect item not found */
  #define GET_BLOCK_NO_ISEM     8 /* i_sem is not held, don't preallocate */
  
! static int reiserfs_get_block (struct inode * inode, long block,
  			       struct buffer_head * bh_result, int create);
  
  /* This spinlock guards inode pkey in private part of inode
--- 17,23 ----
  #define GET_BLOCK_READ_DIRECT 4  /* read the tail if indirect item not found */
  #define GET_BLOCK_NO_ISEM     8 /* i_sem is not held, don't preallocate */
  
! static int reiserfs_get_block (struct inode * inode, sector_t block,
  			       struct buffer_head * bh_result, int create);
  
  /* This spinlock guards inode pkey in private part of inode
***************
*** 221,227 ****
  // Please improve the english/clarity in the comment above, as it is
  // hard to understand.
  
! static int _get_block_create_0 (struct inode * inode, long block,
  				 struct buffer_head * bh_result,
  				 int args)
  {
--- 221,227 ----
  // Please improve the english/clarity in the comment above, as it is
  // hard to understand.
  
! static int _get_block_create_0 (struct inode * inode, sector_t block,
  				 struct buffer_head * bh_result,
  				 int args)
  {
***************
*** 230,236 ****
      struct buffer_head * bh;
      struct item_head * ih, tmp_ih;
      int fs_gen ;
!     int blocknr;
      char * p = NULL;
      int chars;
      int ret ;
--- 230,236 ----
      struct buffer_head * bh;
      struct item_head * ih, tmp_ih;
      int fs_gen ;
!     sector_t blocknr;
      char * p = NULL;
      int chars;
      int ret ;
***************
*** 383,391 ****
  
  // this is called to create file map. So, _get_block_create_0 will not
  // read direct item
! int reiserfs_bmap (struct inode * inode, long block,
  		   struct buffer_head * bh_result, int create)
  {
      if (!file_capable (inode, block))
  	return -EFBIG;
  
--- 383,393 ----
  
  // this is called to create file map. So, _get_block_create_0 will not
  // read direct item
! int reiserfs_bmap (struct inode * inode, sector_t block,
  		   struct buffer_head * bh_result, int create)
  {
+     if (unlikely(sizeof(sector_t) > 4 && (block >> 32)))
+ 	return -EFBIG;
      if (!file_capable (inode, block))
  	return -EFBIG;
  
***************
*** 413,424 ****
  ** don't want to send create == GET_BLOCK_NO_HOLE to reiserfs_get_block, 
  ** don't use this function.
  */
! static int reiserfs_get_block_create_0 (struct inode * inode, long block,
  			struct buffer_head * bh_result, int create) {
      return reiserfs_get_block(inode, block, bh_result, GET_BLOCK_NO_HOLE) ;
  }
  
! static int reiserfs_get_block_direct_io (struct inode * inode, long block,
  			struct buffer_head * bh_result, int create) {
      int ret ;
  
--- 415,426 ----
  ** don't want to send create == GET_BLOCK_NO_HOLE to reiserfs_get_block, 
  ** don't use this function.
  */
! static int reiserfs_get_block_create_0 (struct inode * inode, sector_t block,
  			struct buffer_head * bh_result, int create) {
      return reiserfs_get_block(inode, block, bh_result, GET_BLOCK_NO_HOLE) ;
  }
  
! static int reiserfs_get_block_direct_io (struct inode * inode, sector_t block,
  			struct buffer_head * bh_result, int create) {
      int ret ;
  
***************
*** 527,533 ****
      return reiserfs_new_unf_blocknrs (th, inode, allocated_block_nr, path, block);
  }
  
! static int reiserfs_get_block (struct inode * inode, long block,
  			       struct buffer_head * bh_result, int create)
  {
      int repeat, retval;
--- 529,535 ----
      return reiserfs_new_unf_blocknrs (th, inode, allocated_block_nr, path, block);
  }
  
! static int reiserfs_get_block (struct inode * inode, sector_t block,
  			       struct buffer_head * bh_result, int create)
  {
      int repeat, retval;
***************
*** 557,562 ****
--- 559,569 ----
      th.t_trans_id = 0 ;
      version = get_inode_item_key_version (inode);
  
+     if (unlikely(sizeof(block) > 4 && (block >> 32))) {
+         unlock_kernel();
+         return -EIO;
+     }
+ 
      if (block < 0) {
  	unlock_kernel();
  	return -EIO;
***************
*** 571,582 ****
      ** log anything, so we don't need to start a transaction
      */
      if (!(create & GET_BLOCK_CREATE)) {
- 	int ret ;
  	/* find number of block-th logical block of the file */
! 	ret = _get_block_create_0 (inode, block, bh_result, 
  	                           create | GET_BLOCK_READ_DIRECT) ;
  	unlock_kernel() ;
! 	return ret;
      }
  
      /* If file is of such a size, that it might have a tail and tails are enabled
--- 578,588 ----
      ** log anything, so we don't need to start a transaction
      */
      if (!(create & GET_BLOCK_CREATE)) {
  	/* find number of block-th logical block of the file */
! 	retval = _get_block_create_0 (inode, block, bh_result, 
  	                           create | GET_BLOCK_READ_DIRECT) ;
  	unlock_kernel() ;
! 	return retval;
      }
  
      /* If file is of such a size, that it might have a tail and tails are enabled
***************
*** 912,919 ****
      pop_journal_writer(windex) ;
      unlock_kernel() ;
      reiserfs_check_path(&path) ;
!     return retval;
! }
  
  
  //
--- 918,926 ----
      pop_journal_writer(windex) ;
      unlock_kernel() ;
      reiserfs_check_path(&path) ;
!   
!   return retval;
! } 
  
  
  //
***************
*** 2123,2130 ****
  }
  
  
! static int reiserfs_aop_bmap(struct address_space *as, long block) {
!   return generic_block_bmap(as, block, reiserfs_bmap) ;
  }
  
  static int reiserfs_commit_write(struct file *f, struct page *page, 
--- 2130,2137 ----
  }
  
  
! static sector_t reiserfs_aop_bmap(struct address_space *as, sector_t block) {
!     return generic_block_bmap(as, block, reiserfs_bmap) ;
  }
  
  static int reiserfs_commit_write(struct file *f, struct page *page, 
***************
*** 2219,2225 ****
  }
  
  static int reiserfs_direct_io(int rw, struct inode *inode, 
!                               struct kiobuf *iobuf, unsigned long blocknr,
  			      int blocksize) 
  {
      lock_kernel();
--- 2226,2232 ----
  }
  
  static int reiserfs_direct_io(int rw, struct inode *inode, 
!                               struct kiobuf *iobuf, sector_t blocknr,
  			      int blocksize) 
  {
      lock_kernel();
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/reiserfs/journal.c linux-2.4.22-ashuariadevel/fs/reiserfs/journal.c
*** linux-2.4.22-ashuariadevel.backup/fs/reiserfs/journal.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/reiserfs/journal.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1011,1025 ****
      ** is not marked JDirty_wait
      */
      if ((!was_jwait) && !buffer_locked(saved_bh)) {
! reiserfs_warning(s, "journal-813: BAD! buffer %lu %cdirty %cjwait, not in a newer tranasction\n", saved_bh->b_blocknr,
          was_dirty ? ' ' : '!', was_jwait ? ' ' : '!') ;
      }
      /* kupdate_one_transaction waits on the buffers it is writing, so we
      ** should never see locked buffers here
      */
      if (buffer_locked(saved_bh)) {
!       reiserfs_warning(s, "clm-2083: locked buffer %lu in flush_journal_list\n", 
!               saved_bh->b_blocknr) ;
        wait_on_buffer(saved_bh) ;
        if (!buffer_uptodate(saved_bh)) {
          reiserfs_panic(s, "journal-923: buffer write failed\n") ;
--- 1011,1025 ----
      ** is not marked JDirty_wait
      */
      if ((!was_jwait) && !buffer_locked(saved_bh)) {
! 	    reiserfs_warning(s, "journal-813: BAD! buffer %llu %cdirty %cjwait, not in a newer tranasction\n", (unsigned long long)saved_bh->b_blocknr,
          was_dirty ? ' ' : '!', was_jwait ? ' ' : '!') ;
      }
      /* kupdate_one_transaction waits on the buffers it is writing, so we
      ** should never see locked buffers here
      */
      if (buffer_locked(saved_bh)) {
!       reiserfs_warning(s, "clm-2083: locked buffer %llu in flush_journal_list\n", 
! 		       (unsigned long long)saved_bh->b_blocknr) ;
        wait_on_buffer(saved_bh) ;
        if (!buffer_uptodate(saved_bh)) {
          reiserfs_panic(s, "journal-923: buffer write failed\n") ;
***************
*** 1032,1039 ****
        submit_logged_buffer(saved_bh) ;
        count++ ;
      } else {
!       reiserfs_warning(s, "clm-2082: Unable to flush buffer %lu in flush_journal_list\n",
!               saved_bh->b_blocknr) ;
      }
  free_cnode:
      last = cn ;
--- 1032,1039 ----
        submit_logged_buffer(saved_bh) ;
        count++ ;
      } else {
!       reiserfs_warning(s, "clm-2082: Unable to flush buffer %llu in flush_journal_list\n",
! 		       (unsigned long long)saved_bh->b_blocknr) ;
      }
  free_cnode:
      last = cn ;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/reiserfs/prints.c linux-2.4.22-ashuariadevel/fs/reiserfs/prints.c
*** linux-2.4.22-ashuariadevel.backup/fs/reiserfs/prints.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/reiserfs/prints.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 138,145 ****
  
  static void sprintf_buffer_head (char * buf, struct buffer_head * bh) 
  {
!   sprintf (buf, "dev %s, size %d, blocknr %ld, count %d, list %d, state 0x%lx, page %p, (%s, %s, %s)",
! 	   kdevname (bh->b_dev), bh->b_size, bh->b_blocknr, atomic_read (&(bh->b_count)), bh->b_list,
  	   bh->b_state, bh->b_page,
  	   buffer_uptodate (bh) ? "UPTODATE" : "!UPTODATE",
  	   buffer_dirty (bh) ? "DIRTY" : "CLEAN",
--- 138,145 ----
  
  static void sprintf_buffer_head (char * buf, struct buffer_head * bh) 
  {
!   sprintf (buf, "dev %s, size %d, blocknr %llu, count %d, list %d, state 0x%lx, page %p, (%s, %s, %s)",
! 	   kdevname (bh->b_dev), bh->b_size, (unsigned long long)bh->b_blocknr, atomic_read (&(bh->b_count)), bh->b_list,
  	   bh->b_state, bh->b_page,
  	   buffer_uptodate (bh) ? "UPTODATE" : "!UPTODATE",
  	   buffer_dirty (bh) ? "DIRTY" : "CLEAN",
***************
*** 372,378 ****
      if (tb) {
  	while (tb->insert_size[h]) {
  	    bh = PATH_H_PBUFFER (path, h);
! 	    printk ("block %lu (level=%d), position %d\n", bh ? bh->b_blocknr : 0,
  		    bh ? B_LEVEL (bh) : 0, PATH_H_POSITION (path, h));
  	    h ++;
  	}
--- 372,378 ----
      if (tb) {
  	while (tb->insert_size[h]) {
  	    bh = PATH_H_PBUFFER (path, h);
! 	    printk ("block %llu (level=%d), position %d\n", bh ? (unsigned long long)bh->b_blocknr : 0ULL,
  		    bh ? B_LEVEL (bh) : 0, PATH_H_POSITION (path, h));
  	    h ++;
  	}
***************
*** 382,389 ****
        printk ("Offset    Bh     (b_blocknr, b_count) Position Nr_item\n");
        while ( offset > ILLEGAL_PATH_ELEMENT_OFFSET ) {
  	  bh = PATH_OFFSET_PBUFFER (path, offset);
! 	  printk ("%6d %10p (%9lu, %7d) %8d %7d\n", offset, 
! 		  bh, bh ? bh->b_blocknr : 0, bh ? atomic_read (&(bh->b_count)) : 0,
  		  PATH_OFFSET_POSITION (path, offset), bh ? B_NR_ITEMS (bh) : -1);
  	  
  	  offset --;
--- 382,389 ----
        printk ("Offset    Bh     (b_blocknr, b_count) Position Nr_item\n");
        while ( offset > ILLEGAL_PATH_ELEMENT_OFFSET ) {
  	  bh = PATH_OFFSET_PBUFFER (path, offset);
! 	  printk ("%6d %10p (%9llu, %7d) %8d %7d\n", offset, 
! 		  bh, (unsigned long long)(bh ? bh->b_blocknr : 0), bh ? atomic_read (&(bh->b_count)) : 0,
  		  PATH_OFFSET_POSITION (path, offset), bh ? B_NR_ITEMS (bh) : -1);
  	  
  	  offset --;
***************
*** 514,521 ****
  	return 1;
      }
  
!     printk ("%s\'s super block in block %ld\n======================\n",
!             kdevname (bh->b_dev), bh->b_blocknr);
      printk ("Reiserfs version %s\n", version );
      printk ("Block count %u\n", sb_block_count(rs));
      printk ("Blocksize %d\n", sb_blocksize(rs));
--- 514,521 ----
  	return 1;
      }
  
!     printk ("%s\'s super block in block %llu\n======================\n",
!             kdevname (bh->b_dev), (unsigned long long)bh->b_blocknr);
      printk ("Reiserfs version %s\n", version );
      printk ("Block count %u\n", sb_block_count(rs));
      printk ("Blocksize %d\n", sb_blocksize(rs));
***************
*** 552,559 ****
      if (memcmp(desc->j_magic, JOURNAL_DESC_MAGIC, 8))
  	return 1;
  
!     printk ("Desc block %lu (j_trans_id %d, j_mount_id %d, j_len %d)",
! 	    bh->b_blocknr, desc->j_trans_id, desc->j_mount_id, desc->j_len);
  
      return 0;
  }
--- 552,559 ----
      if (memcmp(desc->j_magic, JOURNAL_DESC_MAGIC, 8))
  	return 1;
  
!     printk ("Desc block %llu (j_trans_id %d, j_mount_id %d, j_len %d)",
! 	    (unsigned long long)bh->b_blocknr, desc->j_trans_id, desc->j_mount_id, desc->j_len);
  
      return 0;
  }
***************
*** 578,584 ****
  	if (print_internal (bh, first, last))
  	    if (print_super_block (bh))
  		if (print_desc_block (bh))
! 		    printk ("Block %ld contains unformatted data\n", bh->b_blocknr);
  }
  
  
--- 578,584 ----
  	if (print_internal (bh, first, last))
  	    if (print_super_block (bh))
  		if (print_desc_block (bh))
! 		    printk ("Block %llu contains unformatted data\n", (unsigned long long)bh->b_blocknr);
  }
  
  
***************
*** 613,631 ****
  	    tbFh = 0;
  	}
  	sprintf (print_tb_buf + strlen (print_tb_buf),
! 		 "* %d * %3ld(%2d) * %3ld(%2d) * %3ld(%2d) * %5ld * %5ld * %5ld * %5ld * %5ld *\n",
  		 h, 
! 		 (tbSh) ? (tbSh->b_blocknr):(-1),
  		 (tbSh) ? atomic_read (&(tbSh->b_count)) : -1,
! 		 (tb->L[h]) ? (tb->L[h]->b_blocknr):(-1),
  		 (tb->L[h]) ? atomic_read (&(tb->L[h]->b_count)) : -1,
! 		 (tb->R[h]) ? (tb->R[h]->b_blocknr):(-1),
  		 (tb->R[h]) ? atomic_read (&(tb->R[h]->b_count)) : -1,
! 		 (tbFh) ? (tbFh->b_blocknr):(-1),
! 		 (tb->FL[h]) ? (tb->FL[h]->b_blocknr):(-1),
! 		 (tb->FR[h]) ? (tb->FR[h]->b_blocknr):(-1),
! 		 (tb->CFL[h]) ? (tb->CFL[h]->b_blocknr):(-1),
! 		 (tb->CFR[h]) ? (tb->CFR[h]->b_blocknr):(-1));
      }
  
      sprintf (print_tb_buf + strlen (print_tb_buf), 
--- 613,631 ----
  	    tbFh = 0;
  	}
  	sprintf (print_tb_buf + strlen (print_tb_buf),
! 		 "* %d * %3llu(%2d) * %3llu(%2d) * %3llu(%2d) * %5llu * %5llu * %5llu * %5llu * %5llu *\n",
  		 h, 
! 		 (unsigned long long)((tbSh) ? (tbSh->b_blocknr):(-1)),
  		 (tbSh) ? atomic_read (&(tbSh->b_count)) : -1,
! 		 (unsigned long long)((tb->L[h]) ? (tb->L[h]->b_blocknr):(-1)),
  		 (tb->L[h]) ? atomic_read (&(tb->L[h]->b_count)) : -1,
! 		 (unsigned long long)((tb->R[h]) ? (tb->R[h]->b_blocknr):(-1)),
  		 (tb->R[h]) ? atomic_read (&(tb->R[h]->b_count)) : -1,
! 		 (unsigned long long)((tbFh) ? (tbFh->b_blocknr):(-1)),
! 		 (unsigned long long)((tb->FL[h]) ? (tb->FL[h]->b_blocknr):(-1)),
! 		 (unsigned long long)((tb->FR[h]) ? (tb->FR[h]->b_blocknr):(-1)),
! 		 (unsigned long long)((tb->CFL[h]) ? (tb->CFL[h]->b_blocknr):(-1)),
! 		 (unsigned long long)((tb->CFR[h]) ? (tb->CFR[h]->b_blocknr):(-1)));
      }
  
      sprintf (print_tb_buf + strlen (print_tb_buf), 
***************
*** 652,658 ****
      h = 0;
      for (i = 0; i < sizeof (tb->FEB) / sizeof (tb->FEB[0]); i ++)
  	sprintf (print_tb_buf + strlen (print_tb_buf),
! 		 "%p (%lu %d)%s", tb->FEB[i], tb->FEB[i] ? tb->FEB[i]->b_blocknr : 0,
  		 tb->FEB[i] ? atomic_read (&(tb->FEB[i]->b_count)) : 0, 
  		 (i == sizeof (tb->FEB) / sizeof (tb->FEB[0]) - 1) ? "\n" : ", ");
  
--- 652,658 ----
      h = 0;
      for (i = 0; i < sizeof (tb->FEB) / sizeof (tb->FEB[0]); i ++)
  	sprintf (print_tb_buf + strlen (print_tb_buf),
! 		 "%p (%llu %d)%s", tb->FEB[i], (unsigned long long)(tb->FEB[i] ? tb->FEB[i]->b_blocknr : 0),
  		 tb->FEB[i] ? atomic_read (&(tb->FEB[i]->b_count)) : 0, 
  		 (i == sizeof (tb->FEB) / sizeof (tb->FEB[0]) - 1) ? "\n" : ", ");
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/reiserfs/super.c linux-2.4.22-ashuariadevel/fs/reiserfs/super.c
*** linux-2.4.22-ashuariadevel.backup/fs/reiserfs/super.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/reiserfs/super.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 923,930 ****
      if (!is_any_reiserfs_magic_string (rs) || sb_blocksize(rs) !=
  	s->s_blocksize) {
        printk ("sh-2011: read_super_block: "
! 	      "can't find a reiserfs filesystem on (dev %s, block %lu, size %lu)\n",
! 	      kdevname(s->s_dev), bh->b_blocknr, s->s_blocksize);    
        brelse (bh);
        return 1;
      }
--- 923,930 ----
      if (!is_any_reiserfs_magic_string (rs) || sb_blocksize(rs) !=
  	s->s_blocksize) {
        printk ("sh-2011: read_super_block: "
! 	      "can't find a reiserfs filesystem on (dev %s, block %llu, size %lu)\n",
! 	      kdevname(s->s_dev), (unsigned long long)bh->b_blocknr, s->s_blocksize);
        brelse (bh);
        return 1;
      }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/sysv/itree.c linux-2.4.22-ashuariadevel/fs/sysv/itree.c
*** linux-2.4.22-ashuariadevel.backup/fs/sysv/itree.c	2002-02-26 04:38:09.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/sysv/itree.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 191,197 ****
  	return -EAGAIN;
  }
  
! static int get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create)
  {
  	int err = -EIO;
  	int offsets[DEPTH];
--- 191,197 ----
  	return -EAGAIN;
  }
  
! static int get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	int err = -EIO;
  	int offsets[DEPTH];
***************
*** 425,431 ****
  {
  	return block_prepare_write(page,from,to,get_block);
  }
! static int sysv_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,get_block);
  }
--- 425,431 ----
  {
  	return block_prepare_write(page,from,to,get_block);
  }
! static sector_t sysv_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/udf/inode.c linux-2.4.22-ashuariadevel/fs/udf/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/udf/inode.c	2002-08-03 09:39:45.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/udf/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 61,67 ****
  static void udf_update_extents(struct inode *,
  	long_ad [EXTENT_MERGE_SIZE], int, int,
  	lb_addr, uint32_t, struct buffer_head **);
! static int udf_get_block(struct inode *, long, struct buffer_head *, int);
  
  /*
   * udf_put_inode
--- 61,67 ----
  static void udf_update_extents(struct inode *,
  	long_ad [EXTENT_MERGE_SIZE], int, int,
  	lb_addr, uint32_t, struct buffer_head **);
! static int udf_get_block(struct inode *, sector_t, struct buffer_head *, int);
  
  /*
   * udf_put_inode
***************
*** 146,152 ****
  	return block_prepare_write(page, from, to, udf_get_block);
  }
  
! static int udf_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,udf_get_block);
  }
--- 146,152 ----
  	return block_prepare_write(page, from, to, udf_get_block);
  }
  
! static sector_t udf_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,udf_get_block);
  }
***************
*** 311,317 ****
  	return dbh;
  }
  
! static int udf_get_block(struct inode *inode, long block, struct buffer_head *bh_result, int create)
  {
  	int err, new;
  	struct buffer_head *bh;
--- 311,317 ----
  	return dbh;
  }
  
! static int udf_get_block(struct inode *inode, sector_t block, struct buffer_head *bh_result, int create)
  {
  	int err, new;
  	struct buffer_head *bh;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/ufs/inode.c linux-2.4.22-ashuariadevel/fs/ufs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/ufs/inode.c	2002-02-26 04:38:09.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/ufs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 308,314 ****
  	return result;
  }
  
! static int ufs_getfrag_block (struct inode *inode, long fragment, struct buffer_head *bh_result, int create)
  {
  	struct super_block * sb;
  	struct ufs_sb_private_info * uspi;
--- 308,314 ----
  	return result;
  }
  
! static int ufs_getfrag_block (struct inode *inode, sector_t fragment, struct buffer_head *bh_result, int create)
  {
  	struct super_block * sb;
  	struct ufs_sb_private_info * uspi;
***************
*** 463,469 ****
  {
  	return block_prepare_write(page,from,to,ufs_getfrag_block);
  }
! static int ufs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,ufs_getfrag_block);
  }
--- 463,469 ----
  {
  	return block_prepare_write(page,from,to,ufs_getfrag_block);
  }
! static sector_t ufs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,ufs_getfrag_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/asm-i386/types.h linux-2.4.22-ashuariadevel/include/asm-i386/types.h
*** linux-2.4.22-ashuariadevel.backup/include/asm-i386/types.h	2004-01-19 17:47:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/asm-i386/types.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 52,57 ****
--- 52,61 ----
  #endif
  typedef u64 dma64_addr_t;
  
+ #ifdef CONFIG_LBD
+ typedef u64 sector_t;
+ #define HAVE_ARCH_SECTOR_T
+ #endif
  #endif /* __KERNEL__ */
  
  #endif
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/asm-ppc/types.h linux-2.4.22-ashuariadevel/include/asm-ppc/types.h
*** linux-2.4.22-ashuariadevel.backup/include/asm-ppc/types.h	2003-06-13 23:51:38.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/asm-ppc/types.h	2004-02-02 14:35:09.000000000 +0900
***************
*** 45,50 ****
--- 45,56 ----
  typedef u32 dma_addr_t;
  typedef u64 dma64_addr_t;
  
+ #ifdef CONFIG_LBD
+ typedef u64 sector_t;
+ #define HAVE_ARCH_SECTOR_T
+ #endif
+ 
+ 
  #endif /* __KERNEL__ */
  
  /*
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/blkdev.h linux-2.4.22-ashuariadevel/include/linux/blkdev.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/blkdev.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/blkdev.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 34,42 ****
  	int cmd;		/* READ or WRITE */
  	int errors;
  	unsigned long start_time;
! 	unsigned long sector;
  	unsigned long nr_sectors;
! 	unsigned long hard_sector, hard_nr_sectors;
  	unsigned int nr_segments;
  	unsigned int nr_hw_segments;
  	unsigned long current_nr_sectors, hard_cur_sectors;
--- 34,43 ----
  	int cmd;		/* READ or WRITE */
  	int errors;
  	unsigned long start_time;
! 	sector_t sector;
  	unsigned long nr_sectors;
! 	sector_t hard_sector;
! 	unsigned long hard_nr_sectors;
  	unsigned int nr_segments;
  	unsigned int nr_hw_segments;
  	unsigned long current_nr_sectors, hard_cur_sectors;
***************
*** 232,239 ****
  
  extern struct sec_size * blk_sec[MAX_BLKDEV];
  extern struct blk_dev_struct blk_dev[MAX_BLKDEV];
! extern void grok_partitions(struct gendisk *dev, int drive, unsigned minors, long size);
! extern void register_disk(struct gendisk *dev, kdev_t first, unsigned minors, struct block_device_operations *ops, long size);
  extern void generic_make_request(int rw, struct buffer_head * bh);
  extern inline request_queue_t *blk_get_queue(kdev_t dev);
  extern void blkdev_release_request(struct request *);
--- 233,240 ----
  
  extern struct sec_size * blk_sec[MAX_BLKDEV];
  extern struct blk_dev_struct blk_dev[MAX_BLKDEV];
! extern void grok_partitions(struct gendisk *dev, int drive, unsigned minors, sector_t size);
! extern void register_disk(struct gendisk *dev, kdev_t first, unsigned minors, struct block_device_operations *ops, sector_t size);
  extern void generic_make_request(int rw, struct buffer_head * bh);
  extern inline request_queue_t *blk_get_queue(kdev_t dev);
  extern void blkdev_release_request(struct request *);
***************
*** 250,256 ****
  extern void generic_unplug_device(void *);
  extern inline int blk_seg_merge_ok(struct buffer_head *, struct buffer_head *);
  
! extern int * blk_size[MAX_BLKDEV];
  
  extern int * blksize_size[MAX_BLKDEV];
  
--- 251,257 ----
  extern void generic_unplug_device(void *);
  extern inline int blk_seg_merge_ok(struct buffer_head *, struct buffer_head *);
  
! extern sector_t * blk_size[MAX_BLKDEV];
  
  extern int * blksize_size[MAX_BLKDEV];
  
***************
*** 366,369 ****
--- 367,384 ----
  	return retval;
  }
  
+ #ifdef CONFIG_LBD
+ # include <asm/div64.h>
+ # define sector_div(a, b) do_div(a, b)
+ #else
+ # define sector_div(n, b)( \
+ { \
+         int _res; \
+         _res = (n) % (b); \
+         (n) /= (b); \
+         _res; \
+ } \
+ )
+ #endif
+ 
  #endif
